<html>
<head>
<title>OGRE: Ogre::AlignedMemory Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1AlignedMemory.html">AlignedMemory</a></div>
<h1>Ogre::AlignedMemory Class Reference</h1><!-- doxytag: class="Ogre::AlignedMemory" -->Class to provide aligned memory allocate functionality.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreAlignedAllocator_8h-source.html">OgreAlignedAllocator.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1AlignedMemory-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html#215ddaa2cf45c92ec39560dd43bed7b6">allocate</a> (size_t size, size_t alignment)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocate memory with given alignment.  <a href="#215ddaa2cf45c92ec39560dd43bed7b6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html#939feb25c02c78968b57502809ed836a">allocate</a> (size_t size)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocate memory with default platform dependent alignment.  <a href="#939feb25c02c78968b57502809ed836a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html#ec9665c128b282869284a6025520adee">deallocate</a> (void *p)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Deallocate memory that allocated by this class.  <a href="#ec9665c128b282869284a6025520adee"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Class to provide aligned memory allocate functionality. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>All SIMD processing are friendly with aligned memory, and some SIMD routines are designed for working with aligned memory only. If the data are intented to use SIMD processing, it's need to be aligned for better performance boost. In additional, most time cache boundary aligned data also lead to better performance even if didn't used SIMD processing. So this class provides a couple of functions for allocate aligned memory. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Anyways, in general, you don't need to use this class directly, <a class="el" href="namespaceOgre.html">Ogre</a> internally will take care with most SIMD and cache friendly optimisation if possible. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This isn't a "one-step" optimisation, there are a lot of underlying work to achieve performance boost. If you didn't know what are you doing or what there are going, just ignore this class. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This class intented to use by advanced user only. </dd></dl>

<p>Definition at line <a class="el" href="OgreAlignedAllocator_8h-source.html#l00054">54</a> of file <a class="el" href="OgreAlignedAllocator_8h-source.html">OgreAlignedAllocator.h</a>.</p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="215ddaa2cf45c92ec39560dd43bed7b6"></a><!-- doxytag: member="Ogre::AlignedMemory::allocate" ref="215ddaa2cf45c92ec39560dd43bed7b6" args="(size_t size, size_t alignment)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void* Ogre::AlignedMemory::allocate           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>alignment</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Allocate memory with given alignment. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>The size of memory need to allocate. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>alignment</em>&nbsp;</td><td>The alignment of result pointer, must be power of two and in range [1, 128]. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The allocated memory pointer. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>On failiure, exception will be throw. </dd></dl>

<p>Referenced by <a class="el" href="OgreAlignedAllocator_8h-source.html#l00162">Ogre::AlignedAllocator&lt; T, Alignment &gt;::allocate()</a>.</p>

</div>
</div><p>
<a class="anchor" name="939feb25c02c78968b57502809ed836a"></a><!-- doxytag: member="Ogre::AlignedMemory::allocate" ref="939feb25c02c78968b57502809ed836a" args="(size_t size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void* Ogre::AlignedMemory::allocate           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>size</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Allocate memory with default platform dependent alignment. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The default alignment depend on target machine, this function guarantee aligned memory according with SIMD processing and cache boundary friendly. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>The size of memory need to allocate. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The allocated memory pointer. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>On failiure, exception will be throw. </dd></dl>

</div>
</div><p>
<a class="anchor" name="ec9665c128b282869284a6025520adee"></a><!-- doxytag: member="Ogre::AlignedMemory::deallocate" ref="ec9665c128b282869284a6025520adee" args="(void *p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::AlignedMemory::deallocate           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Deallocate memory that allocated by this class. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>p</em>&nbsp;</td><td>Pointer to the memory allocated by this class or <b>NULL</b> pointer. </td></tr>
  </table>
</dl>
<dl class="user" compact><dt><b></b></dt><dd>On <b>NULL</b> pointer, nothing happen. </dd></dl>

<p>Referenced by <a class="el" href="OgreAlignedAllocator_8h-source.html#l00174">Ogre::AlignedAllocator&lt; T, Alignment &gt;::deallocate()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAlignedAllocator_8h-source.html">OgreAlignedAllocator.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:06 2008
</p>
</body>
</html>
